PtrContainer, part of collection of the [Boost C++ Libraries](http://github.com/boostorg), provides containers for holding heap-allocated objects in an exception-safe manner and with minimal overhead.

### License

Distributed under the [Boost Software License, Version 1.0](http://www.boost.org/LICENSE_1_0.txt).

### Properties

* C++03
* Header Only

### Build Status

Branch          | GHA CI | Appveyor | Coverity Scan | codecov.io | Deps | Docs | Tests |
:-------------: | ------ | -------- | ------------- | ---------- | ---- | ---- | ----- |
[`master`](https://github.com/boostorg/ptr_container/tree/master) | [![Build Status](https://github.com/boostorg/ptr_container/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/boostorg/ptr_container/actions?query=branch:master) | [![Build status](https://ci.appveyor.com/api/projects/status/xsoiss46xfe6ilig/branch/master?svg=true)](https://ci.appveyor.com/project/jeking3/ptr-container-lviqw/branch/master) | [![Coverity Scan Build Status](https://scan.coverity.com/projects/15842/badge.svg)](https://scan.coverity.com/projects/boostorg-ptr_container) | [![codecov](https://codecov.io/gh/boostorg/ptr_container/branch/master/graph/badge.svg)](https://codecov.io/gh/boostorg/ptr_container/branch/master)| [![Deps](https://img.shields.io/badge/deps-master-brightgreen.svg)](https://pdimov.github.io/boostdep-report/master/ptr_container.html) | [![Documentation](https://img.shields.io/badge/docs-master-brightgreen.svg)](https://www.boost.org/doc/libs/master/libs/ptr_container/doc/ptr_container.html) | [![Enter the Matrix](https://img.shields.io/badge/matrix-master-brightgreen.svg)](http://www.boost.org/development/tests/master/developer/ptr_container.html)
[`develop`](https://github.com/boostorg/ptr_container/tree/develop) | [![Build Status](https://github.com/boostorg/ptr_container/actions/workflows/ci.yml/badge.svg?branch=develop)](https://github.com/boostorg/ptr_container/actions?query=branch:develop) | [![Build status](https://ci.appveyor.com/api/projects/status/xsoiss46xfe6ilig/branch/develop?svg=true)](https://ci.appveyor.com/project/jeking3/ptr-container-lviqw/branch/develop) | [![Coverity Scan Build Status](https://scan.coverity.com/projects/15842/badge.svg)](https://scan.coverity.com/projects/boostorg-ptr_container) | [![codecov](https://codecov.io/gh/boostorg/ptr_container/branch/develop/graph/badge.svg)](https://codecov.io/gh/boostorg/ptr_container/branch/develop) | [![Deps](https://img.shields.io/badge/deps-develop-brightgreen.svg)](https://pdimov.github.io/boostdep-report/develop/ptr_container.html) | [![Documentation](https://img.shields.io/badge/docs-develop-brightgreen.svg)](https://www.boost.org/doc/libs/develop/libs/ptr_container/doc/ptr_container.html) | [![Enter the Matrix](https://img.shields.io/badge/matrix-develop-brightgreen.svg)](http://www.boost.org/development/tests/develop/developer/ptr_container.html)

### Directories

| Name        | Purpose                        |
| ----------- | ------------------------------ |
| `doc`       | documentation                  |
| `include`   | headers                        |
| `test`      | unit tests                     |

### More information

* [Ask questions](http://stackoverflow.com/questions/ask?tags=c%2B%2B,boost,boost-ptr_container)
* [Report bugs](https://github.com/boostorg/ptr_container/issues): Be sure to mention Boost version, platform and compiler you're using. A small compilable code sample to reproduce the problem is always good as well.
* Submit your patches as pull requests against **develop** branch. Note that by submitting patches you agree to license your modifications under the [Boost Software License, Version 1.0](http://www.boost.org/LICENSE_1_0.txt).
* Discussions about the library are held on the [Boost developers mailing list](http://www.boost.org/community/groups.html#main). Be sure to read the [discussion policy](http://www.boost.org/community/policy.html) before posting and add the `[ptr_container]` tag at the beginning of the subject line.

