Boost.Units
===========

Boost.Units, part of collection of the [Boost C++ Libraries](http://github.com/boostorg),
implements dimensional analysis in a general and extensible manner,
treating it as a generic compile-time metaprogramming problem.
With appropriate compiler optimization, no runtime execution cost is introduced,
facilitating the use of this library to provide dimension checking in performance-critical code.

### Directories

* **doc** - QuickBook documentation sources
* **example** - examples
* **images** - images for documention
* **include** - Interface headers
* **test** - unit tests
* **test_headers** - unit tests for self containment of headers
* **tutorial** - tutorial

### Test results

@       | Travis      | AppVeyor
--------|-------------|---------
master  | [![Build Status](https://travis-ci.org/boostorg/units.svg?branch=master)](https://travis-ci.org/boostorg/units) | [![Build Status](https://ci.appveyor.com/api/projects/status/github/boostorg/units?branch=master&svg=true)](https://ci.appveyor.com/project/boostorg/units)
develop | [![Build Status](https://travis-ci.org/boostorg/units.svg)](https://travis-ci.org/boostorg/units) | [![Build Status](https://ci.appveyor.com/api/projects/status/github/boostorg/units?svg=true)](https://ci.appveyor.com/project/boostorg/units)

<a href="https://scan.coverity.com/projects/boostorg-units">
  <img alt="Coverity Scan Build Status"
       src="https://img.shields.io/coverity/scan/14037.svg"/>
</a>

### More information

* [Documentation](http://boost.org/libs/units)

### License

Distributed under the [Boost Software License, Version 1.0](http://www.boost.org/LICENSE_1_0.txt).
